#!/bin/bash

#SERVER="carter.openprojects.net"
OWNER_NICK="[Hh]erkamire"  # the bot will quit if this person does "/msg $NICK quit" (can be a regular expression)
CHANNEL="#forth"
CHANNEL_I="#[fF][oO][rR][tT][hH]"
#CHANNEL="#forthos"
#CHANNEL_I="#[fF][oO][rR][tT][hH][oO][sS]"
NICK="sifbot"
NICK_I="[sS][iI][fF][bB][oO][tT]"
USER="sifforth"
FULL_NAME="sif (Safe Interpreted Forth) bot - by herkamire. Tell me forth code and I'll execute it (prefix with \"$NICK: \" or \"/msg $NICK\""
GREETING="Type $NICK: <forth code here> (or /msg $NICK <forth code here> to play in private)"

echo -e "NICK $NICK\r" >&7
echo -e "<output> NICK $NICK\r" >>log
echo -e "USER $USER 0 * :$FULL_NAME\r" >&7
echo -e "<output> USER $USER 0 * :$FULL_NAME\r" >>log
echo -e "JOIN $CHANNEL\r" >&7
echo -e "<output> JOIN $CHANNEL\r" >>log
if test "$GREETING" != "" ; then
    echo -e "PRIVMSG $CHANNEL :$GREETING\r" >&7
    echo -e "<output> PRIVMSG $CHANNEL :$GREETING\r" >>log
fi

QUIT_NOW=0

while test "$QUIT_NOW" = "0" ; do
    ./read > tmp <&6
    if [ "`cat tmp`" = "" ] #disconnected
    then
    	echo 'DISCONNECTED!!!!!!!!!!!' >> log
    	exit 1;
    fi
    echo -n "<input > " >> log
    cat tmp >> log
    echo "<end>" >> log

    IS_MESSAGE=`cat tmp | sed  -ne "s/.*PRIVMSG $CHANNEL_I :$NICK: .*/YES/p"`
    if test "$IS_MESSAGE" = "YES" ; then
	
	cat tmp | sed  -ne "s/.*$CHANNEL_I :$NICK: \(.*\)/\1/p" > tmp2
	FROM_NICK=`cat tmp | sed  -ne 's/^:\([a-zA-Z_0-9.]*\)!.*$/\1/p'`

	MESSAGE_PREFIX="PRIVMSG $CHANNEL :$FROM_NICK: "
    else
	IS_MESSAGE=`cat tmp | sed  -ne "s/.*PRIVMSG $NICK_I :.*/YES/p"`
	if test "$IS_MESSAGE" = "YES" ; then
	    
	    cat tmp | sed  -ne "s/.*PRIVMSG $NICK_I :\(.*\)/\1/p" > tmp2
	    FROM_NICK=`cat tmp | sed  -ne 's/^:\([a-zA-Z_0-9.]*\)!.*$/\1/p'`
	    
	    MESSAGE_PREFIX="PRIVMSG $FROM_NICK :"
	fi
    fi
	

    if test "$IS_MESSAGE" = "YES" ; then
	if test "`cat tmp | sed -ne \"s/^:$OWNER_NICK!.*PRIVMSG $NICK_I :quit.*/quit/p\"`" '=' "quit" ; then
	    QUIT_NOW=yes
	    QUIT_MESSAGE="`cat tmp | sed -ne \"s/^:$OWNER_NICK!.*PRIVMSG $NICK_I :quit //p\"`"
	    echo -e "QUIT :$QUIT_MESSAGE\r" >&7
	    echo -e "<output> QUIT :$QUIT_MESSAGE\r" >> log
	    sleep 3 #wait for the quit message to have a chance to get through before we close the connection
	else
	    if test "$FROM_NICK" != "" ; then
		rm -f tmp3
		cat t.fs tmp2 | ./sif > tmp3 &
		sleep 1
		kill $! 2>/dev/null >/dev/null
		echo -n "<output> " >> log
		cat tmp3 | ./write "$MESSAGE_PREFIX" >&7
		cat tmp3 | ./write "$MESSAGE_PREFIX" >> log
	    else
		echo "<error > Could not get nickname PRIVMSG was from." >> log
	    fi
	fi
    else
	# not a message to the bot.

	# Handle PINGs
	IS_PING=`cat tmp | sed  -ne "s/^PING.*/YES/p"`
	if test "$IS_PING" = "YES" ; then
	    PING_DEST=`cat tmp | sed  -ne 's/^PING \([^ ]*\).*/\1/p'`
	    if test "$PING_DEST" = "" ; then
		echo "<error > Could not determine who to send PONG to." >> log
	    else
		echo -e "PONG $PING_DEST\r" >&7
		echo -e "<output> PONG $PING_DEST" >> log
	    fi
	fi	
    fi
    
done



